| http://www.sim.no/ http://www.coin3d.org/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoInteractionKit Class Reference
NodeKit Classes

The SoInteractionKit class is a base class for draggers.This nodekit class makes it possible to set surrogate paths for parts. Instead of creating new geometry for the dragger, it is possible to specify an existing path in your scene to be used for interaction. All picks on this path will be handled by the dragger. More...

`#include <Inventor/nodekits/SoInteractionKit.h>`

Inheritance diagram for SoInteractionKit:

## Public Types

enum | CacheEnabled { OFF, ON, AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoInteractionKit ()
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields ()
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoInteractionKit class is a base class for draggers.

This nodekit class makes it possible to set surrogate paths for parts. Instead of creating new geometry for the dragger, it is possible to specify an existing path in your scene to be used for interaction. All picks on this path will be handled by the dragger.

The SoInteractionKit is primarily an internal class used as a superclass for the dragger classes, and it is unlikely that it should be of interest to application programmers, unless you have very special needs in your application.

Node kit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoInteractionKit
    -->"this"
          "callbackList"
    -->   "topSeparator"
    -->      "geomSeparator"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoInteractionKit
    PVT   "this",  SoInteractionKit  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "geomSeparator",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## Member Enumeration Documentation

## ◆ CacheEnabled

enum SoInteractionKit::CacheEnabled

Enumeration of valid values for the cache control fields SoInteractionKit::renderCaching, SoInteractionKit::boundingBoxCaching, SoInteractionKit::renderCulling and SoInteractionKit::pickCulling.

The same values with the same semantics are present in this enum as for SoSeparator::CacheEnabled, so see that documentation.

## Constructor & Destructor Documentation

## ◆ SoInteractionKit()

SoInteractionKit::SoInteractionKit | ( | void |  | ) |

Constructor.

## ◆ ~SoInteractionKit()

SoInteractionKit::~SoInteractionKit | ( |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoInteractionKit::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoBaseKit.

Reimplemented in SoDragger, SoTrackballDragger, SoRotateSphericalDragger, SoSpotLightDragger, SoTransformerDragger, SoHandleBoxDragger, SoScale2UniformDragger, SoTabPlaneDragger, SoTranslate1Dragger, SoTranslate2Dragger, SoCenterballDragger, SoDirectionalLightDragger, SoJackDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoScale1Dragger, SoScale2Dragger, SoScaleUniformDragger, SoTransformBoxDragger, SoDragPointDragger, SoPointLightDragger, and SoTabBoxDragger.

## ◆ getFieldData()

const SoFieldData * SoInteractionKit::getFieldData | ( | void |  | ) | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoBaseKit.

Reimplemented in SoDragger, SoTrackballDragger, SoRotateSphericalDragger, SoSpotLightDragger, SoTransformerDragger, SoHandleBoxDragger, SoScale2UniformDragger, SoTabPlaneDragger, SoTranslate1Dragger, SoTranslate2Dragger, SoCenterballDragger, SoDirectionalLightDragger, SoJackDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoScale1Dragger, SoScale2Dragger, SoScaleUniformDragger, SoTransformBoxDragger, SoDragPointDragger, SoPointLightDragger, and SoTabBoxDragger.

## ◆ getNodekitCatalog()

const SoNodekitCatalog * SoInteractionKit::getNodekitCatalog | ( | void |  | ) | const

virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoBaseKit.

Reimplemented in SoDragger, SoTrackballDragger, SoRotateSphericalDragger, SoSpotLightDragger, SoTransformerDragger, SoHandleBoxDragger, SoScale2UniformDragger, SoTabPlaneDragger, SoTranslate1Dragger, SoTranslate2Dragger, SoCenterballDragger, SoDirectionalLightDragger, SoJackDragger, SoRotateCylindricalDragger, SoRotateDiscDragger, SoScale1Dragger, SoScale2Dragger, SoScaleUniformDragger, SoTransformBoxDragger, SoDragPointDragger, SoPointLightDragger, and SoTabBoxDragger.

## ◆ setPartAsPath()

SbBool SoInteractionKit::setPartAsPath | ( | const SbName & | partname,
|  | SoPath * | path
| ) |  |

virtual

Sets a part in the kit as a surrogate path. The partname part is set to `NULL`, and the surrogate path is remembered. Following picks on the surrogate path will be regarded as a pick on partname.

## ◆ setPartAsDefault() [1/2]

SbBool SoInteractionKit::setPartAsDefault | ( | const SbName & | partname,
|  | SoNode * | node,
|  | SbBool | onlyifdefault = `TRUE`
| ) |  |

virtual

Sets the value of partname to node, and sets the part's field to default (i.e. node will not be written on scene graph export).

If onlyifdefault is `TRUE`, partname is only set if it is already in the default state.

The reason for this method is to make it possible for dragger subclasses to avoid having their default parts written out on export.

## ◆ setPartAsDefault() [2/2]

SbBool SoInteractionKit::setPartAsDefault | ( | const SbName & | partname,
|  | const SbName & | nodename,
|  | SbBool | onlyifdefault = `TRUE`
| ) |  |

virtual

Find node in the global dictionary, and set as default.

See also
  setPartAsDefault()

## ◆ isPathSurrogateInMySubgraph() [1/2]

SbBool SoInteractionKit::isPathSurrogateInMySubgraph | ( | const SoPath * | path,
|  | SoPath *& | pathToOwner,
|  | SbName & | surrogatename,
|  | SoPath *& | surrogatepath,
|  | SbBool | fillargs = `TRUE`
| ) |  |

Checks if path is contained within any of the surrogate paths in any interaction kits from this node down. Returns information about the owner and the surrogate path if found, and fillargs is TRUE. The returned path (pathToOwner) is not ref'ed, It's the callers responsibility to ref and unref this path.

## ◆ isPathSurrogateInMySubgraph() [2/2]

SbBool SoInteractionKit::isPathSurrogateInMySubgraph | ( | const SoPath * | path | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setSwitchValue()

void SoInteractionKit::setSwitchValue | ( | SoNode * | node,
|  | const int | newVal
| ) |  |

static

Convenience method that sets the switch value for a switch node. Checks if node != 0, and only sets the switch value if value has changed.

## ◆ setPart() [1/2]

SbBool SoInteractionKit::setPart | ( | const SbName & | partname,
|  | SoNode * | from
| ) |  |

virtual

Sets the catalog part given by partname to the from node pointer.

Reimplemented from SoBaseKit.

## ◆ copyContents()

void SoInteractionKit::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |

protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoBaseKit.

Reimplemented in SoRotateSphericalDragger, and SoRotateCylindricalDragger.

## ◆ setPart() [2/2]

SbBool SoInteractionKit::setPart | ( | const int | partnum,
|  | SoNode * | node
| ) |  |

protectedvirtual

Sets parts, updates nodekit scene graph, and makes sure graph is valid with respect to right siblings and parent. This method is virtual to enable subclasses to detect when a part changes value.

This method is not part of the original SGI Open Inventor API, but is an extension specific to Coin.

Reimplemented from SoBaseKit.

## ◆ readInstance()

SbBool SoInteractionKit::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |

protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoBaseKit.

## ◆ readDefaultParts()

void SoInteractionKit::readDefaultParts | ( | const char * | fileName,
|  | const char | defaultBuffer[],
|  | int | defBufSize
| ) |  |

staticprotected

Reads default parts for a dragger.

This method is called from dragger constructors to set up a dragger's nodekit catalog of interaction and feedback geometry.

fileName is the user-changeable resource file in the Inventor file format, while defaultBuffer and defBufSize can point to the statically compiled default parts.

The environment variable `SO_DRAGGER_DIR` must be set to a valid directory prefix for fileName, or no resource file will be loaded (and defaultBuffer will be used instead).

If both a fileName and a defaultBuffer is provided, the file will be attempted found and loaded first, if that fails, the geometry will be attempted read from the buffer.

## ◆ setAnyPartAsDefault() [1/2]

SbBool SoInteractionKit::setAnyPartAsDefault | ( | const SbName & | partname,
|  | SoNode * | node,
|  | SbBool | anypart = `TRUE`,
|  | SbBool | onlyifdefault = `TRUE`
| ) |  |

protectedvirtual

Protected version of setPartAsDefault(), to make it possible to set non-leaf and private parts (if anypart is `TRUE`).

See also
  setPartAsDefault()

## ◆ setAnyPartAsDefault() [2/2]

SbBool SoInteractionKit::setAnyPartAsDefault | ( | const SbName & | partname,
|  | const SbName & | nodename,
|  | SbBool | anypart = `TRUE`,
|  | SbBool | onlyifdefault = `TRUE`
| ) |  |

protectedvirtual

Protected version of setPartAsDefault(), to make it possible to set non-leaf and private parts (if anypart is `TRUE`).

See also
  setPartAsDefault()

## ◆ setAnySurrogatePath()

SbBool SoInteractionKit::setAnySurrogatePath | ( | const SbName & | partname,
|  | SoPath * | path,
|  | SbBool | leafcheck = `FALSE`,
|  | SbBool | publiccheck = `FALSE`
| ) |  |

protected

Protected version of setPartAsPath(), to make it possible to set non-leaf and private parts.

("The nice thing about C++ is that only your friends can handle your private parts.")

See also
  setPartAsPath()

## ◆ setUpConnections()

SbBool SoInteractionKit::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = `FALSE`
| ) |  |

protectedvirtual

Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoBaseKit.

Reimplemented in SoTransformerDragger, SoHandleBoxDragger, SoDragPointDragger, SoTransformBoxDragger, SoTrackballDragger, SoCenterballDragger, SoTabPlaneDragger, SoTabBoxDragger, SoSpotLightDragger, SoTranslate2Dragger, SoRotateSphericalDragger, SoRotateCylindricalDragger, SoTranslate1Dragger, SoDirectionalLightDragger, SoJackDragger, SoScale2UniformDragger, SoRotateDiscDragger, SoScale1Dragger, SoScale2Dragger, SoScaleUniformDragger, and SoPointLightDragger.

## ◆ setDefaultOnNonWritingFields()

void SoInteractionKit::setDefaultOnNonWritingFields | ( | void |  | ) |

protectedvirtual

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it's of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoBaseKit.

Reimplemented in SoTransformerDragger, SoDragger, SoHandleBoxDragger, SoDragPointDragger, SoTransformBoxDragger, SoTrackballDragger, SoCenterballDragger, SoTabPlaneDragger, SoTabBoxDragger, SoSpotLightDragger, SoDirectionalLightDragger, SoJackDragger, and SoPointLightDragger.

## ◆ fieldSensorCB()

void SoInteractionKit::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ connectSeparatorFields()

void SoInteractionKit::connectSeparatorFields | ( | SoSeparator * | dest,
|  | SbBool | onOff
| ) |  |

protected

Obsoleted in Coin.

## Member Data Documentation

## ◆ renderCaching

SoSFEnum SoInteractionKit::renderCaching

Controls the value of the SoSeparator::renderCaching field in the SoInteractionKit catalog's topSeparator instance.

See documentation of SoSeparator::renderCaching.

## ◆ boundingBoxCaching

SoSFEnum SoInteractionKit::boundingBoxCaching

Controls the value of the SoSeparator::boundingBoxCaching field in the SoInteractionKit catalog's topSeparator instance.

See documentation of SoSeparator::boundingBoxCaching.

## ◆ renderCulling

SoSFEnum SoInteractionKit::renderCulling

Controls the value of the SoSeparator::renderCulling field in the SoInteractionKit catalog's topSeparator instance.

See documentation of SoSeparator::renderCulling.

## ◆ pickCulling

SoSFEnum SoInteractionKit::pickCulling

Controls the value of the SoSeparator::pickCulling field in the SoInteractionKit catalog's topSeparator instance.

See documentation of SoSeparator::pickCulling.

## ◆ fieldSensor

SoFieldSensor * SoInteractionKit::fieldSensor

protected

Obsoleted in Coin.

## ◆ oldTopSep

SoFieldSensor * SoInteractionKit::oldTopSep

protected

Obsoleted in Coin.

The documentation for this class was generated from the following files:

- SoInteractionKit.h
- SoInteractionKit.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.